edelib: TiXmlDocument Class Reference

edelib 1.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
TiXmlDocument Class Reference

Top level node. More...

`#include <edelib/TiXml.h>`

Inheritance diagram for TiXmlDocument:

## Public Member Functions
| TiXmlDocument ()
| TiXmlDocument (const char *documentName)
| TiXmlDocument (const TiXmlDocument &copy)
void | operator= (const TiXmlDocument &copy)
bool | LoadFile (TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
bool | SaveFile () const
bool | LoadFile (const char *filename, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
bool | SaveFile (const char *filename) const
bool | LoadFile (FILE *, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
bool | SaveFile (FILE *) const
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
const TiXmlElement * | RootElement () const
TiXmlElement * | RootElement ()
bool | Error () const
const char * | ErrorDesc () const
int | ErrorId () const
int | ErrorRow () const
int | ErrorCol () const
void | SetTabSize (int _tabsize)
int | TabSize () const
void | ClearError ()
void | Print () const
virtual void | Print (FILE *cfile, int depth=0) const
virtual const TiXmlDocument * | ToDocument () const
virtual TiXmlDocument * | ToDocument ()
virtual bool | Accept (TiXmlVisitor *content) const
Public Member Functions inherited from TiXmlNode
const char * | Value () const
void | SetValue (const char *_value)
void | Clear ()
TiXmlNode * | Parent ()
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
const TiXmlNode * | PreviousSibling () const
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
virtual const TiXmlElement * | ToElement () const
virtual const TiXmlComment * | ToComment () const
virtual const TiXmlUnknown * | ToUnknown () const
virtual const TiXmlText * | ToText () const
virtual const TiXmlDeclaration * | ToDeclaration () const
virtual TiXmlElement * | ToElement ()
virtual TiXmlComment * | ToComment ()
virtual TiXmlUnknown * | ToUnknown ()
virtual TiXmlText * | ToText ()
virtual TiXmlDeclaration * | ToDeclaration ()
virtual TiXmlNode * | Clone () const =0
Public Member Functions inherited from TiXmlBase
int | Row () const
int | Column () const
void | SetUserData (void *user)
void * | GetUserData ()
const void * | GetUserData () const

## Additional Inherited Members
Public Types inherited from TiXmlNode
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
Protected Member Functions inherited from TiXmlNode
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)
Static Protected Member Functions inherited from TiXmlBase
static const char * | ReadName (const char *p, edelib::String *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, edelib::String *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static void | PutString (const edelib::String &str, edelib::String *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Top level node.

Always the top level node. A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

## Constructor & Destructor Documentation

TiXmlDocument | ( |  | ) |

Create an empty document, that has no name.

TiXmlDocument | ( | const char * | documentName | ) |

Create a document with a name. The name of the document is also the filename of the xml.

TiXmlDocument | ( | const TiXmlDocument & | copy | ) |

Constructor

## Member Function Documentation

virtual bool Accept | ( | TiXmlVisitor * | content | ) | const
| virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

void ClearError | ( |  | ) |
| inline

If you have handled the error, it can be reset with this call. The error state is automatically cleared if you Parse a new XML block.

bool Error | ( |  | ) | const
| inline

If an error occurs, Error will be set to true. Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

int ErrorCol | ( |  | ) | const
| inline

The column where the error occured. See ErrorRow()

const char* ErrorDesc | ( |  | ) | const
| inline

Contains a textual (english) description of the error if one occurs.

int ErrorId | ( |  | ) | const
| inline

Generally, you probably want the error string ( ErrorDesc() ). But if you prefer the ErrorId, this function will fetch it.

int ErrorRow | ( |  | ) | const
| inline

Returns the location (if known) of the error. The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See also
  SetTabSize, Row, Column

bool LoadFile | ( | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` | ) |

Load a file using the current document value. Returns true if successful. Will delete any existing document data before loading.

bool LoadFile | ( | const char * | filename,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given filename. Returns true if successful.

bool LoadFile | ( | FILE * | ,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given FILE*. Returns true if successful. Note that this method doesn't stream - the entire object pointed at by the FILE* will be interpreted as an XML file. TinyXML doesn't stream in XML from the current file location. Streaming may be added in the future.

void operator= | ( | const TiXmlDocument & | copy | ) |

Assignement from another TiXmlDocument

Referenced by TiXmlBase::ToLower().

virtual const char* Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = `0`,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |
| virtual

Parse the given null terminated block of xml data. Passing in an encoding to this method (either TIXML_ENCODING_LEGACY or TIXML_ENCODING_UTF8 will force TinyXml to use that encoding, regardless of what TinyXml might otherwise try to detect.

Referenced by TiXmlBase::GetUserData().

void Print | ( |  | ) | const
| inline

Write the document to standard out using formatted printing ("pretty print").

References Print().

Referenced by Print().

virtual void Print | ( | FILE * | cfile,
|  | int | depth = `0`
| ) |  | const
| virtual

Write the document to a string using formatted printing ("pretty print"). This will allocate a character array (new char[]) and return it as a pointer. The calling code pust call delete[] on the return char* to avoid a memory leak.Print this Document to a FILE stream.

Implements TiXmlBase.

const TiXmlElement* RootElement | ( |  | ) | const
| inline

Get the root element – the only top level element – of the document. In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

TiXmlElement* RootElement | ( |  | ) |
| inline

Non-const RootElement() form

bool SaveFile | ( |  | ) | const

Save a file using the current document value. Returns true if successful.

bool SaveFile | ( | const char * | filename | ) | const

Save a file using the given filename. Returns true if successful.

bool SaveFile | ( | FILE * |  | ) | const

Save a file using the given FILE*. Returns true if successful.

void SetTabSize | ( | int | _tabsize | ) |
| inline

SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column. It does not change the output or input in any way.

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    *   TiXmlDocument doc;
    *   doc.SetTabSize( 8 );
    *   doc.Load( "myfile.xml" );
    *

See also
  Row, Column

int TabSize | ( |  | ) | const
| inline

Return current tab size

virtual const TiXmlDocument* ToDocument | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

virtual TiXmlDocument* ToDocument | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

The documentation for this class was generated from the following file:

- edelib/TiXml.h